import glob
import os
import re
from sys import argv

# main
if __name__ == '__main__':

	# passed variables
	FILE_PATH = argv[1]

	# open file and read contents
	with open(FILE_PATH, 'r') as f:
		paths = f.readlines()
		f.close()

	# recursively open files, retrieve correct line and store in dict
	out_dict = {}

	for p in paths:
		p = p.strip()
		alignment = p.split('/')[2]
		species = p.split('/')[3]
		sample = p.split('/')[-1].split('_')[0]
		#print('{}\t{}\t{}'.format(alignment, species, sample))
		with open(p) as f:
			for line in f.readlines():
				line = line.strip()
				if not line:
					continue
				elif re.search(r'properly paired %', line):  # this will retrieve the percentage of properly paired mapped reads
					percentage = line.split('\t')[0]
					break
		f.close()
		key = '{}\t{}'.format(alignment, sample)
		out_dict[key] = '{}\t{}'.format(species, percentage)

	# write out file with all collected information
	with open('../results/alignment_stats.tsv', 'w') as f:
		for key in out_dict.keys():
			f.write("{}\t{}\n".format(key, out_dict[key]))
		f.close()
