import csv
import os
import re
import pandas as pd
from sys import argv

# main
if __name__ == '__main__':
    
    # passed variables
    IN_TXT = argv[1]
    OUT_PATH = argv[2]

    # read in all paths
    with open(IN_TXT, "r") as inf:
        lines = inf.readlines()

    # iterate over paths and process the StringTie outputs
    list_dfs = []
    for line in lines:
        sample = line.split()[0]
        path = line.split()[1]
        dict_curr = {}
        print('\t retrieving TPM counts from {}'.format(path))
        with open(path, 'r') as f:
            for line in f:
                line = line.strip()
                if re.search(r'\stranscript\s', line):
                    #print(line)
                    if re.search(r'gene_id[^;]+', line):
                        gene_id = re.search(r'gene_id[^;]+', line)\
                            .group().split('"')[1].split('.')[0]
                    else:
                    # in some cases, the TPM file will not contain gene_id info
                        gene_id = re.search(r'transcript_id[^;]+', line)\
                            .group().split('"')[1].split('.')[0]
                    tpm = re.search(r'TPM[^;]+', line)\
                        .group().split('"')[1]
                    dict_curr[gene_id] = tpm
                else:
                    continue

        list_dfs.append(pd.DataFrame.from_dict(dict_curr,\
            orient = 'index', columns = [sample]))

    df_all = pd.concat(list_dfs, axis=1)
    df_all.to_csv(OUT_PATH)
    print('\nwrote data to {}'.format(OUT_PATH))
