# get_KEGG_pathway_genes.R
# author: Francesco Garassino

# given a KEGG A. thaliana pathway code, allows to retrieve all the 
# corresponding genes from TAIR

## - NB this won't retrieve chloroplast genes! - ##

easypackages::packages(c('tidyverse', 'org.At.tair.db'))

# retrieve date
ddmm <- paste(rev(str_split_1(as.character(Sys.Date()), '-'))[1:2], collapse = '')

path = 'ath00196' # Photosynthesis - antenna proteins
path = 'ath00195' # Photosynthesis

# Import relevant database
x <- org.At.tairPATH
# Get the TAIR identifiers that are mapped to a KEGG pathway ID
mapped_genes <- mappedkeys(x)
# Convert to a list
list_mapped_genes <- as.list(x[mapped_genes])

genes_path = character()

for(i in 1:length(list_mapped_genes)){
  gene = list_mapped_genes[i]
  if(grepl(gsub('ath', '', path), gene)){
    genes_path <- append(genes_path, names(gene))
  }
}

write_delim(tibble(genes_path),
            paste0('./outputs/', path, '_list_', ddmm,'.txt'),
            delim = '', col_names = FALSE)

# pathways.list <- keggList("pathway", "ath")

# pathway.codes <- sub("path:", "", names(pathways.list)) 
# genes.by.pathway <- sapply(pathway.codes,
#                            function(pwid){
#                              pw <- keggGet(pwid)
#                              if (is.null(pw[[1]]$GENE)) return(NA)
#                              pw2 <- pw[[1]]$GENE[c(TRUE,FALSE)] # may need to modify this to c(FALSE, TRUE) for other organisms
#                              pw2 <- unlist(lapply(strsplit(pw2, split = ";", fixed = T), function(x)x[1]))
#                              return(pw2)
#                            }
# )
# 
# head(genes.by.pathway)

# genes_names <- keggGet(path)[[1]]$GENE
# 
# genes <- genes_names[c(TRUE, FALSE)]

# ath_kegg <- limma::getGeneKEGGLinks(species.KEGG = "ath", convert = FALSE)
# ath_kegg_entrez <- limma::getGeneKEGGLinks(species.KEGG = "ath", convert = TRUE)
# 
# all <- bind_cols(ath_kegg, ath_kegg_entrez) %>% 
#   janitor::clean_names()
# 
# all_path <- all %>%
#   filter(pathway_id_2 == paste0('path:', path))

# genes <- ath_kegg %>% 
#   filter(PathwayID == paste0('path:', path)) %>% 
#   pull(GeneID)

# x <- org.At.tairENTREZID
# mapped_genes <- mappedkeys(x)
# xx <- as.list(x[mapped_genes])
# 
#  for(i in 1:length(xx)){
#   gene = xx[i]
#   if(grepl(gsub('ath', '', path), gene)){}
#  }
# 
# 
# write_delim(tibble(genes),
#             paste0('./outputs/', path, '_list_', ddmm,'.txt'),
#             delim = '', col_names = FALSE)

